# Use inputs for dynamic behavior
spec:
  inputs:
    stage:
      default: deploy to production
      description: 'The pipeline stage where the deploy job should run'
    app_id:
      default: $APP_ID
      description: 'The application ID to be used with clever link'
    ci_default_branch:
      default: $CI_DEFAULT_BRANCH
      description: 'The default branch name for the CI'
    when:
      default: manual
      description: 'When to trigger the job'

---

variables:
  GIT_DEPTH: 0

before_script:
  - CC_VERSION=latest
  - curl -s -O https://clever-tools.clever-cloud.com/releases/${CC_VERSION}/clever-tools-${CC_VERSION}_linux.tar.gz
  - tar -xvf clever-tools-${CC_VERSION}_linux.tar.gz
  - PATH=${PATH}:$(pwd)/clever-tools-${CC_VERSION}_linux

deploy to production:
  stage: $[[ inputs.stage ]]
  image: node:latest
  script:
    - clever link $[[ inputs.app_id ]]
    - clever deploy
  environment: production
  when: $[[ inputs.when ]]
  rules:
    - if: $CI_COMMIT_BRANCH == $[[ inputs.ci_default_branch ]]
